/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30802

/* Bison version string.  */
#define YYBISON_VERSION "3.8.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* First part of user prologue.  */
#line 18 "parser.y"

#include "parser.h"
#include <limits.h>

#include "utils.h"

#define abort(...)				\
{						\
	fprintf(stderr, __VA_ARGS__);		\
	YYABORT;				\
}

#define check_and_free_keyword(identifier, expected)			\
{									\
	if (strcmp(identifier, expected))				\
		abort("Wrong keyword: %s expected, %s received\n",	\
		      expected, identifier);				\
	free(identifier);						\
}



#line 94 "parser.tab.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

#include "parser.tab.h"
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_IDENTIFIER = 3,                 /* IDENTIFIER  */
  YYSYMBOL_STRING = 4,                     /* STRING  */
  YYSYMBOL_SRCFILE = 5,                    /* SRCFILE  */
  YYSYMBOL_CONSTANT = 6,                   /* CONSTANT  */
  YYSYMBOL_NEWLINE = 7,                    /* NEWLINE  */
  YYSYMBOL_TYPEDEF = 8,                    /* TYPEDEF  */
  YYSYMBOL_CONST = 9,                      /* CONST  */
  YYSYMBOL_VOLATILE = 10,                  /* VOLATILE  */
  YYSYMBOL_RESTRICT = 11,                  /* RESTRICT  */
  YYSYMBOL_STRUCT = 12,                    /* STRUCT  */
  YYSYMBOL_UNION = 13,                     /* UNION  */
  YYSYMBOL_ENUM = 14,                      /* ENUM  */
  YYSYMBOL_ELLIPSIS = 15,                  /* ELLIPSIS  */
  YYSYMBOL_VERSION_KW = 16,                /* VERSION_KW  */
  YYSYMBOL_CU_KW = 17,                     /* CU_KW  */
  YYSYMBOL_FILE_KW = 18,                   /* FILE_KW  */
  YYSYMBOL_STACK_KW = 19,                  /* STACK_KW  */
  YYSYMBOL_SYMBOL_KW_NL = 20,              /* SYMBOL_KW_NL  */
  YYSYMBOL_ARROW = 21,                     /* ARROW  */
  YYSYMBOL_UNKNOWN_FIELD = 22,             /* UNKNOWN_FIELD  */
  YYSYMBOL_NAMESPACE = 23,                 /* NAMESPACE  */
  YYSYMBOL_24_ = 24,                       /* '.'  */
  YYSYMBOL_25_ = 25,                       /* ':'  */
  YYSYMBOL_26_ = 26,                       /* '{'  */
  YYSYMBOL_27_ = 27,                       /* '}'  */
  YYSYMBOL_28_ = 28,                       /* '-'  */
  YYSYMBOL_29_ = 29,                       /* '='  */
  YYSYMBOL_30_ = 30,                       /* '('  */
  YYSYMBOL_31_ = 31,                       /* ')'  */
  YYSYMBOL_32_ = 32,                       /* '*'  */
  YYSYMBOL_33_ = 33,                       /* '['  */
  YYSYMBOL_34_ = 34,                       /* ']'  */
  YYSYMBOL_35_ = 35,                       /* '@'  */
  YYSYMBOL_YYACCEPT = 36,                  /* $accept  */
  YYSYMBOL_kabi_dw_file = 37,              /* kabi_dw_file  */
  YYSYMBOL_fmt_version = 38,               /* fmt_version  */
  YYSYMBOL_header = 39,                    /* header  */
  YYSYMBOL_header_field = 40,              /* header_field  */
  YYSYMBOL_cu_field = 41,                  /* cu_field  */
  YYSYMBOL_source_file_field = 42,         /* source_file_field  */
  YYSYMBOL_stack_field = 43,               /* stack_field  */
  YYSYMBOL_stack_list = 44,                /* stack_list  */
  YYSYMBOL_stack_elt = 45,                 /* stack_elt  */
  YYSYMBOL_symbol = 46,                    /* symbol  */
  YYSYMBOL_alignment = 47,                 /* alignment  */
  YYSYMBOL_byte_size = 48,                 /* byte_size  */
  YYSYMBOL_namespace = 49,                 /* namespace  */
  YYSYMBOL_declaration = 50,               /* declaration  */
  YYSYMBOL_declaration_typedef = 51,       /* declaration_typedef  */
  YYSYMBOL_declaration_var = 52,           /* declaration_var  */
  YYSYMBOL_type = 53,                      /* type  */
  YYSYMBOL_struct_type = 54,               /* struct_type  */
  YYSYMBOL_struct_list = 55,               /* struct_list  */
  YYSYMBOL_struct_elt = 56,                /* struct_elt  */
  YYSYMBOL_union_type = 57,                /* union_type  */
  YYSYMBOL_enum_type = 58,                 /* enum_type  */
  YYSYMBOL_enum_list = 59,                 /* enum_list  */
  YYSYMBOL_enum_elt = 60,                  /* enum_elt  */
  YYSYMBOL_func_type = 61,                 /* func_type  */
  YYSYMBOL_arg_list = 62,                  /* arg_list  */
  YYSYMBOL_variable_var_list = 63,         /* variable_var_list  */
  YYSYMBOL_elt_list = 64,                  /* elt_list  */
  YYSYMBOL_elt = 65,                       /* elt  */
  YYSYMBOL_ptr_type = 66,                  /* ptr_type  */
  YYSYMBOL_array_type = 67,                /* array_type  */
  YYSYMBOL_typed_type = 68,                /* typed_type  */
  YYSYMBOL_type_qualifier = 69,            /* type_qualifier  */
  YYSYMBOL_base_type = 70,                 /* base_type  */
  YYSYMBOL_reference_file = 71,            /* reference_file  */
  YYSYMBOL_asm_symbol = 72,                /* asm_symbol  */
  YYSYMBOL_weak_symbol = 73                /* weak_symbol  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_uint8 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if !defined yyoverflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined yyoverflow */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  5
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   227

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  36
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  38
/* YYNRULES -- Number of rules.  */
#define YYNRULES  78
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  169

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   278


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
      30,    31,    32,     2,     2,    28,    24,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    25,     2,
       2,    29,     2,     2,    35,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    33,     2,    34,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    26,     2,    27,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23
};

#if YYDEBUG
/* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,    79,    79,    87,    95,    97,   101,   102,   103,   104,
     108,   115,   122,   125,   127,   131,   138,   142,   147,   153,
     158,   163,   169,   175,   184,   191,   199,   206,   207,   208,
     209,   210,   211,   212,   213,   217,   224,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   244,   248,   256,   260,
     268,   274,   280,   291,   305,   309,   318,   327,   331,   339,
     347,   355,   364,   367,   371,   379,   387,   391,   399,   406,
     413,   421,   429,   434,   439,   447,   455,   463,   471
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if YYDEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "IDENTIFIER", "STRING",
  "SRCFILE", "CONSTANT", "NEWLINE", "TYPEDEF", "CONST", "VOLATILE",
  "RESTRICT", "STRUCT", "UNION", "ENUM", "ELLIPSIS", "VERSION_KW", "CU_KW",
  "FILE_KW", "STACK_KW", "SYMBOL_KW_NL", "ARROW", "UNKNOWN_FIELD",
  "NAMESPACE", "'.'", "':'", "'{'", "'}'", "'-'", "'='", "'('", "')'",
  "'*'", "'['", "']'", "'@'", "$accept", "kabi_dw_file", "fmt_version",
  "header", "header_field", "cu_field", "source_file_field", "stack_field",
  "stack_list", "stack_elt", "symbol", "alignment", "byte_size",
  "namespace", "declaration", "declaration_typedef", "declaration_var",
  "type", "struct_type", "struct_list", "struct_elt", "union_type",
  "enum_type", "enum_list", "enum_elt", "func_type", "arg_list",
  "variable_var_list", "elt_list", "elt", "ptr_type", "array_type",
  "typed_type", "type_qualifier", "base_type", "reference_file",
  "asm_symbol", "weak_symbol", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#define YYPACT_NINF (-121)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-1)

#define yytable_value_is_error(Yyn) \
  0

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
static const yytype_int16 yypact[] =
{
      -9,    17,    12,  -121,     4,  -121,   187,    18,    66,    73,
      74,    76,  -121,  -121,  -121,  -121,  -121,    75,    80,    55,
    -121,    -1,    89,    92,    93,    94,    98,  -121,   132,   176,
     189,    95,  -121,  -121,  -121,  -121,  -121,  -121,  -121,  -121,
    -121,  -121,    99,    88,   104,   105,   107,  -121,   112,    96,
      97,   106,   126,     1,   189,   134,     0,   132,   189,   136,
     141,  -121,   144,   120,   149,     6,  -121,   151,  -121,  -121,
    -121,   154,   161,   163,   164,  -121,  -121,  -121,  -121,  -121,
    -121,  -121,  -121,   163,  -121,  -121,  -121,  -121,   163,   162,
     171,   173,  -121,   117,   174,  -121,   189,   179,   180,  -121,
    -121,  -121,  -121,  -121,   170,  -121,  -121,   168,  -121,   157,
    -121,  -121,    31,    26,   190,  -121,   201,  -121,  -121,   163,
     181,   203,  -121,   163,    60,  -121,   204,  -121,  -121,   206,
     165,   207,  -121,  -121,  -121,   208,   213,  -121,   163,   214,
     212,    56,    30,   215,    42,   163,   150,   216,  -121,  -121,
     163,   191,  -121,  -121,  -121,  -121,  -121,  -121,  -121,  -121,
    -121,  -121,   218,     8,   163,   217,  -121,   163,  -121
};

/* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const yytype_int8 yydefact[] =
{
       0,     0,     0,     4,     0,     1,     0,     0,     0,     0,
       0,     0,     9,     5,     6,     7,     8,     0,     0,     0,
      13,     0,     0,     0,     0,     0,     0,     2,     0,     0,
       0,     0,    31,    32,    27,    28,    29,    30,    34,    33,
       3,    10,     0,    12,    77,     0,     0,    61,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    16,     0,     0,     0,     0,    75,     0,    72,    73,
      74,     0,     0,     0,     0,    36,    39,    40,    41,    42,
      43,    44,    45,     0,    37,    38,    24,    76,     0,     0,
       0,     0,    26,    77,     0,    17,     0,     0,     0,    20,
      19,    11,    15,    14,     0,    25,    78,    62,    69,     0,
      71,    35,     0,     0,     0,    18,     0,    21,    22,     0,
       0,     0,    66,     0,     0,    46,     0,    48,    54,     0,
       0,     0,    57,    23,    68,     0,    63,    70,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    67,    50,
       0,     0,    47,    49,    55,    59,    56,    58,    60,    65,
      64,    51,     0,     0,     0,     0,    52,     0,    53
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -121,  -121,  -121,  -121,  -121,  -121,  -121,  -121,  -121,  -121,
    -121,   193,  -121,    14,    46,  -121,  -121,   -73,   -10,  -121,
      84,    -3,     2,  -121,    82,    10,  -121,  -121,   114,  -120,
    -121,  -121,  -121,  -121,  -121,    -4,  -121,  -121
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_uint8 yydefgoto[] =
{
       0,     2,     3,     6,    13,    14,    15,    16,    43,    64,
      27,    28,    29,    30,    31,    32,    33,    75,    76,   126,
     127,    77,    78,   131,   132,    79,   120,   147,   121,   122,
      80,    81,    82,    83,    84,    85,    38,    39
};

/* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_uint8 yytable[] =
{
     108,    34,    44,    93,    93,    45,    45,     1,    35,   104,
     110,   164,     5,    36,   165,   111,   148,    47,    34,    34,
      34,    37,   148,     4,    17,    35,    35,    35,     7,   119,
      36,    36,    36,   119,    46,    46,    46,   124,    37,    37,
      37,    46,    54,    58,    34,   130,   134,    34,    34,    47,
     137,    35,    47,   128,    35,    35,    36,   154,   125,    36,
      36,    47,   124,   138,    37,   149,   139,    37,    37,   156,
      18,    96,   158,   134,    55,    59,    60,   161,    19,    21,
      42,    20,    40,   152,    22,   140,    34,    41,    23,    24,
      25,   166,    48,    35,   168,    49,    50,    51,    36,    26,
      94,    52,    61,    97,    98,    62,    37,    65,    66,    63,
      67,    87,    86,    68,    69,    70,    23,    24,    25,    88,
      65,    66,    89,    90,   102,    71,    68,    69,    70,    23,
      24,    25,    91,    92,    72,    53,    73,    74,    71,    46,
      22,    95,   116,    99,    23,    24,    25,    72,   100,    73,
      74,   101,    46,    65,    66,    26,   103,   106,   105,    68,
      69,    70,    23,    24,    25,   159,    65,    66,   107,   112,
     109,   119,    68,    69,    70,    23,    24,    25,   113,    56,
     114,   115,    73,    74,    22,    46,   117,   118,    23,    24,
      25,   123,    53,   130,   143,    73,    74,    22,    46,    26,
      72,    23,    24,    25,     8,     9,    10,    11,   133,    12,
     136,   141,   135,   142,   144,   145,   146,   150,   151,   162,
     167,   155,    57,   160,   163,   153,   157,   129
};

static const yytype_uint8 yycheck[] =
{
      73,    11,     3,     3,     3,     6,     6,    16,    11,     3,
      83,     3,     0,    11,     6,    88,   136,    21,    28,    29,
      30,    11,   142,     6,     6,    28,    29,    30,    24,     3,
      28,    29,    30,     3,    35,    35,    35,     6,    28,    29,
      30,    35,    28,    29,    54,     3,   119,    57,    58,    53,
     123,    54,    56,    27,    57,    58,    54,    27,    27,    57,
      58,    65,     6,     3,    54,   138,     6,    57,    58,    27,
       4,    57,   145,   146,    28,    29,    30,   150,     5,     3,
      25,     7,     7,    27,     8,    25,    96,     7,    12,    13,
      14,   164,     3,    96,   167,     3,     3,     3,    96,    23,
      54,     3,     7,    57,    58,     6,    96,     3,     4,    21,
       6,     4,     7,     9,    10,    11,    12,    13,    14,     7,
       3,     4,    26,    26,     4,    21,     9,    10,    11,    12,
      13,    14,    26,     7,    30,     3,    32,    33,    21,    35,
       8,     7,    96,     7,    12,    13,    14,    30,     7,    32,
      33,     7,    35,     3,     4,    23,     7,     3,     7,     9,
      10,    11,    12,    13,    14,    15,     3,     4,     7,     7,
       6,     3,     9,    10,    11,    12,    13,    14,     7,     3,
       7,     7,    32,    33,     8,    35,     7,     7,    12,    13,
      14,    34,     3,     3,    29,    32,    33,     8,    35,    23,
      30,    12,    13,    14,    17,    18,    19,    20,     7,    22,
       7,     7,    31,     7,     7,     7,     3,     3,     6,    28,
       3,     6,    29,     7,     6,   141,   144,   113
};

/* YYSTOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const yytype_int8 yystos[] =
{
       0,    16,    37,    38,     6,     0,    39,    24,    17,    18,
      19,    20,    22,    40,    41,    42,    43,     6,     4,     5,
       7,     3,     8,    12,    13,    14,    23,    46,    47,    48,
      49,    50,    51,    52,    54,    57,    58,    61,    72,    73,
       7,     7,    25,    44,     3,     6,    35,    71,     3,     3,
       3,     3,     3,     3,    49,    50,     3,    47,    49,    50,
      50,     7,     6,    21,    45,     3,     4,     6,     9,    10,
      11,    21,    30,    32,    33,    53,    54,    57,    58,    61,
      66,    67,    68,    69,    70,    71,     7,     4,     7,    26,
      26,    26,     7,     3,    50,     7,    49,    50,    50,     7,
       7,     7,     4,     7,     3,     7,     3,     7,    53,     6,
      53,    53,     7,     7,     7,     7,    50,     7,     7,     3,
      62,    64,    65,    34,     6,    27,    55,    56,    27,    64,
       3,    59,    60,     7,    53,    31,     7,    53,     3,     6,
      25,     7,     7,    29,     7,     7,     3,    63,    65,    53,
       3,     6,    27,    56,    27,     6,    27,    60,    53,    15,
       7,    53,    28,     6,     3,     6,    53,     3,    53
};

/* YYR1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr1[] =
{
       0,    36,    37,    38,    39,    39,    40,    40,    40,    40,
      41,    42,    43,    44,    44,    45,    46,    46,    46,    46,
      46,    46,    46,    46,    47,    48,    49,    50,    50,    50,
      50,    50,    50,    50,    50,    51,    52,    53,    53,    53,
      53,    53,    53,    53,    53,    53,    54,    54,    55,    55,
      56,    56,    56,    56,    57,    57,    58,    59,    59,    60,
      61,    61,    62,    62,    62,    63,    64,    64,    65,    66,
      67,    68,    69,    69,    69,    70,    71,    72,    73
};

/* YYR2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     4,     5,     0,     2,     1,     1,     1,     1,
       3,     5,     3,     0,     3,     2,     2,     3,     4,     3,
       3,     4,     4,     5,     3,     4,     3,     1,     1,     1,
       1,     1,     1,     1,     1,     4,     3,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     5,     7,     1,     3,
       3,     4,     7,     8,     5,     7,     7,     1,     3,     3,
       8,     2,     0,     2,     4,     2,     1,     3,     2,     2,
       4,     2,     1,     1,     1,     1,     2,     2,     4
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYNOMEM         goto yyexhaustedlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (root, YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)




# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value, root); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, obj_t **root)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  YY_USE (root);
  if (!yyvaluep)
    return;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, obj_t **root)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep, root);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule, obj_t **root)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)], root);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule, root); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep, obj_t **root)
{
  YY_USE (yyvaluep);
  YY_USE (root);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (obj_t **root)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */

  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    YYNOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        YYNOMEM;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          YYNOMEM;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */


  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 2: /* kabi_dw_file: fmt_version header SYMBOL_KW_NL symbol  */
#line 80 "parser.y"
        {
		(yyval.obj) = *root = (yyvsp[0].obj);
		obj_fill_parent(*root);
	}
#line 1278 "parser.tab.c"
    break;

  case 3: /* fmt_version: VERSION_KW CONSTANT '.' CONSTANT NEWLINE  */
#line 88 "parser.y"
        {
		if (((yyvsp[-3].ul) != FILEFMT_VERSION_MAJOR) |
		    ((yyvsp[-1].ul) > FILEFMT_VERSION_MINOR))
			abort("Unsupported file version: %lu.%lu\n", (yyvsp[-3].ul), (yyvsp[-1].ul));
	}
#line 1288 "parser.tab.c"
    break;

  case 10: /* cu_field: CU_KW STRING NEWLINE  */
#line 109 "parser.y"
        {
	    free((yyvsp[-1].str));
	}
#line 1296 "parser.tab.c"
    break;

  case 11: /* source_file_field: FILE_KW SRCFILE ':' CONSTANT NEWLINE  */
#line 116 "parser.y"
        {
	    free((yyvsp[-3].str));
	}
#line 1304 "parser.tab.c"
    break;

  case 15: /* stack_elt: ARROW STRING  */
#line 132 "parser.y"
        {
		free((yyvsp[0].str));
	}
#line 1312 "parser.tab.c"
    break;

  case 16: /* symbol: declaration NEWLINE  */
#line 139 "parser.y"
        {
		(yyval.obj) = (yyvsp[-1].obj);
	}
#line 1320 "parser.tab.c"
    break;

  case 17: /* symbol: alignment declaration NEWLINE  */
#line 143 "parser.y"
        {
		(yyval.obj) = (yyvsp[-1].obj);
		(yyval.obj)->alignment = (yyvsp[-2].ul);
	}
#line 1329 "parser.tab.c"
    break;

  case 18: /* symbol: alignment namespace declaration NEWLINE  */
#line 148 "parser.y"
        {
		(yyval.obj) = (yyvsp[-1].obj);
		(yyval.obj)->alignment = (yyvsp[-3].ul);
		(yyval.obj)->ns = (yyvsp[-2].str);
	}
#line 1339 "parser.tab.c"
    break;

  case 19: /* symbol: namespace declaration NEWLINE  */
#line 154 "parser.y"
        {
		(yyval.obj) = (yyvsp[-1].obj);
		(yyval.obj)->ns = (yyvsp[-2].str);
	}
#line 1348 "parser.tab.c"
    break;

  case 20: /* symbol: byte_size declaration NEWLINE  */
#line 159 "parser.y"
        {
		(yyval.obj) = (yyvsp[-1].obj);
		(yyval.obj)->byte_size = (yyvsp[-2].ul);
	}
#line 1357 "parser.tab.c"
    break;

  case 21: /* symbol: byte_size alignment declaration NEWLINE  */
#line 164 "parser.y"
        {
		(yyval.obj) = (yyvsp[-1].obj);
		(yyval.obj)->byte_size = (yyvsp[-3].ul);
		(yyval.obj)->alignment = (yyvsp[-2].ul);
	}
#line 1367 "parser.tab.c"
    break;

  case 22: /* symbol: byte_size namespace declaration NEWLINE  */
#line 170 "parser.y"
        {
		(yyval.obj) = (yyvsp[-1].obj);
		(yyval.obj)->byte_size = (yyvsp[-3].ul);
		(yyval.obj)->ns = (yyvsp[-2].str);
	}
#line 1377 "parser.tab.c"
    break;

  case 23: /* symbol: byte_size alignment namespace declaration NEWLINE  */
#line 176 "parser.y"
        {
		(yyval.obj) = (yyvsp[-1].obj);
		(yyval.obj)->byte_size = (yyvsp[-4].ul);
		(yyval.obj)->alignment = (yyvsp[-3].ul);
		(yyval.obj)->ns = (yyvsp[-2].str);
	}
#line 1388 "parser.tab.c"
    break;

  case 24: /* alignment: IDENTIFIER CONSTANT NEWLINE  */
#line 185 "parser.y"
        {
		check_and_free_keyword((yyvsp[-2].str), "Alignment");
		(yyval.ul) = (yyvsp[-1].ul);
	}
#line 1397 "parser.tab.c"
    break;

  case 25: /* byte_size: IDENTIFIER IDENTIFIER CONSTANT NEWLINE  */
#line 192 "parser.y"
        {
		check_and_free_keyword((yyvsp[-3].str), "Byte");
		check_and_free_keyword((yyvsp[-2].str), "size");
		(yyval.ul) = (yyvsp[-1].ul);
	}
#line 1407 "parser.tab.c"
    break;

  case 26: /* namespace: NAMESPACE IDENTIFIER NEWLINE  */
#line 200 "parser.y"
        {
		(yyval.str) = (yyvsp[-1].str);
	}
#line 1415 "parser.tab.c"
    break;

  case 35: /* declaration_typedef: TYPEDEF IDENTIFIER NEWLINE type  */
#line 218 "parser.y"
        {
	    (yyval.obj) = obj_typedef_new_add((yyvsp[-2].str), (yyvsp[0].obj));
	}
#line 1423 "parser.tab.c"
    break;

  case 36: /* declaration_var: IDENTIFIER IDENTIFIER type  */
#line 225 "parser.y"
        {
	    check_and_free_keyword((yyvsp[-2].str), "var");
	    (yyval.obj) = obj_var_new_add((yyvsp[-1].str), (yyvsp[0].obj));
	}
#line 1432 "parser.tab.c"
    break;

  case 46: /* struct_type: STRUCT IDENTIFIER '{' NEWLINE '}'  */
#line 245 "parser.y"
        {
	    (yyval.obj) = obj_struct_new((yyvsp[-3].str));
	}
#line 1440 "parser.tab.c"
    break;

  case 47: /* struct_type: STRUCT IDENTIFIER '{' NEWLINE struct_list NEWLINE '}'  */
#line 249 "parser.y"
        {
	    (yyval.obj) = obj_struct_new((yyvsp[-5].str));
	    (yyval.obj)->member_list = (yyvsp[-2].list);
	}
#line 1449 "parser.tab.c"
    break;

  case 48: /* struct_list: struct_elt  */
#line 257 "parser.y"
        {
	    (yyval.list) = obj_list_head_new((yyvsp[0].obj));
	}
#line 1457 "parser.tab.c"
    break;

  case 49: /* struct_list: struct_list NEWLINE struct_elt  */
#line 261 "parser.y"
        {
	    obj_list_add((yyvsp[-2].list), (yyvsp[0].obj));
	    (yyval.list) = (yyvsp[-2].list);
	}
#line 1466 "parser.tab.c"
    break;

  case 50: /* struct_elt: CONSTANT IDENTIFIER type  */
#line 269 "parser.y"
        {
	    (yyval.obj) = obj_struct_member_new_add((yyvsp[-1].str), (yyvsp[0].obj));
	    (yyval.obj)->offset = (yyvsp[-2].ul);
	}
#line 1475 "parser.tab.c"
    break;

  case 51: /* struct_elt: CONSTANT CONSTANT IDENTIFIER type  */
#line 275 "parser.y"
        {
	    (yyval.obj) = obj_struct_member_new_add((yyvsp[-1].str), (yyvsp[0].obj));
	    (yyval.obj)->offset = (yyvsp[-3].ul);
            (yyval.obj)->alignment = (yyvsp[-2].ul);
	}
#line 1485 "parser.tab.c"
    break;

  case 52: /* struct_elt: CONSTANT ':' CONSTANT '-' CONSTANT IDENTIFIER type  */
#line 281 "parser.y"
        {
	    if ((yyvsp[-2].ul) > UCHAR_MAX || (yyvsp[-4].ul) > (yyvsp[-2].ul))
		abort("Invalid offset: %lx:%lu:%lu\n", (yyvsp[-6].ul), (yyvsp[-4].ul), (yyvsp[-2].ul));
	    (yyval.obj) = obj_struct_member_new_add((yyvsp[-1].str), (yyvsp[0].obj));
	    (yyval.obj)->offset = (yyvsp[-6].ul);
	    (yyval.obj)->is_bitfield = 1;
	    (yyval.obj)->first_bit = (yyvsp[-4].ul);
	    (yyval.obj)->last_bit = (yyvsp[-2].ul);
	}
#line 1499 "parser.tab.c"
    break;

  case 53: /* struct_elt: CONSTANT ':' CONSTANT '-' CONSTANT CONSTANT IDENTIFIER type  */
#line 292 "parser.y"
        {
	    if ((yyvsp[-3].ul) > UCHAR_MAX || (yyvsp[-5].ul) > (yyvsp[-3].ul))
		abort("Invalid offset: %lx:%lu:%lu\n", (yyvsp[-7].ul), (yyvsp[-5].ul), (yyvsp[-3].ul));
	    (yyval.obj) = obj_struct_member_new_add((yyvsp[-1].str), (yyvsp[0].obj));
	    (yyval.obj)->offset = (yyvsp[-7].ul);
	    (yyval.obj)->is_bitfield = 1;
	    (yyval.obj)->first_bit = (yyvsp[-5].ul);
	    (yyval.obj)->last_bit = (yyvsp[-3].ul);
	    (yyval.obj)->alignment = (yyvsp[-2].ul);
	}
#line 1514 "parser.tab.c"
    break;

  case 54: /* union_type: UNION IDENTIFIER '{' NEWLINE '}'  */
#line 306 "parser.y"
        {
	    (yyval.obj) = obj_union_new((yyvsp[-3].str));
	}
#line 1522 "parser.tab.c"
    break;

  case 55: /* union_type: UNION IDENTIFIER '{' NEWLINE elt_list NEWLINE '}'  */
#line 310 "parser.y"
        {
	    (yyval.obj) = obj_union_new((yyvsp[-5].str));
	    (yyval.obj)->member_list = (yyvsp[-2].list);
	    (yyvsp[-2].list)->object = (yyval.obj);
	}
#line 1532 "parser.tab.c"
    break;

  case 56: /* enum_type: ENUM IDENTIFIER '{' NEWLINE enum_list NEWLINE '}'  */
#line 319 "parser.y"
        {
	    (yyval.obj) = obj_enum_new((yyvsp[-5].str));
	    (yyval.obj)->member_list = (yyvsp[-2].list);
	    (yyvsp[-2].list)->object = (yyval.obj);
	}
#line 1542 "parser.tab.c"
    break;

  case 57: /* enum_list: enum_elt  */
#line 328 "parser.y"
        {
	    (yyval.list) = obj_list_head_new((yyvsp[0].obj));
	}
#line 1550 "parser.tab.c"
    break;

  case 58: /* enum_list: enum_list NEWLINE enum_elt  */
#line 332 "parser.y"
        {
	    obj_list_add((yyvsp[-2].list), (yyvsp[0].obj));
	    (yyval.list) = (yyvsp[-2].list);
	}
#line 1559 "parser.tab.c"
    break;

  case 59: /* enum_elt: IDENTIFIER '=' CONSTANT  */
#line 340 "parser.y"
        {
	    (yyval.obj) = obj_constant_new((yyvsp[-2].str));
	    (yyval.obj)->constant = (yyvsp[0].ul);
	}
#line 1568 "parser.tab.c"
    break;

  case 60: /* func_type: IDENTIFIER IDENTIFIER '(' NEWLINE arg_list ')' NEWLINE type  */
#line 348 "parser.y"
        {
	    check_and_free_keyword((yyvsp[-7].str), "func");
	    (yyval.obj) = obj_func_new_add((yyvsp[-6].str), (yyvsp[0].obj));
	    (yyval.obj)->member_list = (yyvsp[-3].list);
	    if ((yyvsp[-3].list))
		    (yyvsp[-3].list)->object = (yyval.obj);
	}
#line 1580 "parser.tab.c"
    break;

  case 61: /* func_type: IDENTIFIER reference_file  */
#line 356 "parser.y"
        {
	    check_and_free_keyword((yyvsp[-1].str), "func");
	    (yyval.obj) = obj_func_new_add(NULL, (yyvsp[0].obj));
	}
#line 1589 "parser.tab.c"
    break;

  case 62: /* arg_list: %empty  */
#line 364 "parser.y"
        {
	    (yyval.list) = NULL;
	}
#line 1597 "parser.tab.c"
    break;

  case 63: /* arg_list: elt_list NEWLINE  */
#line 368 "parser.y"
        {
	    (yyval.list) = (yyvsp[-1].list);
	}
#line 1605 "parser.tab.c"
    break;

  case 64: /* arg_list: elt_list NEWLINE variable_var_list NEWLINE  */
#line 372 "parser.y"
        {
	    obj_list_add((yyvsp[-3].list), (yyvsp[-1].obj));
	    (yyval.list) = (yyvsp[-3].list);
	}
#line 1614 "parser.tab.c"
    break;

  case 65: /* variable_var_list: IDENTIFIER ELLIPSIS  */
#line 380 "parser.y"
        {
	    /* TODO: there may be a better solution */
	    (yyval.obj) = obj_var_new_add(NULL, obj_basetype_new(strdup("...")));
	}
#line 1623 "parser.tab.c"
    break;

  case 66: /* elt_list: elt  */
#line 388 "parser.y"
        {
	    (yyval.list) = obj_list_head_new((yyvsp[0].obj));
	}
#line 1631 "parser.tab.c"
    break;

  case 67: /* elt_list: elt_list NEWLINE elt  */
#line 392 "parser.y"
        {
	    obj_list_add((yyvsp[-2].list), (yyvsp[0].obj));
	    (yyval.list) = (yyvsp[-2].list);
	}
#line 1640 "parser.tab.c"
    break;

  case 68: /* elt: IDENTIFIER type  */
#line 400 "parser.y"
        {
	    (yyval.obj) = obj_var_new_add((yyvsp[-1].str), (yyvsp[0].obj));
	}
#line 1648 "parser.tab.c"
    break;

  case 69: /* ptr_type: '*' type  */
#line 407 "parser.y"
        {
	    (yyval.obj) = obj_ptr_new_add((yyvsp[0].obj));
	}
#line 1656 "parser.tab.c"
    break;

  case 70: /* array_type: '[' CONSTANT ']' type  */
#line 414 "parser.y"
        {
	    (yyval.obj) = obj_array_new_add((yyvsp[0].obj));
	    (yyval.obj)->index = (yyvsp[-2].ul);
	}
#line 1665 "parser.tab.c"
    break;

  case 71: /* typed_type: type_qualifier type  */
#line 422 "parser.y"
        {
	    (yyval.obj) = obj_qualifier_new_add((yyvsp[0].obj));
	    (yyval.obj)->base_type = (yyvsp[-1].str);
	}
#line 1674 "parser.tab.c"
    break;

  case 72: /* type_qualifier: CONST  */
#line 430 "parser.y"
        {
	    debug("Qualifier: const\n");
	    (yyval.str) = strdup("const");
	}
#line 1683 "parser.tab.c"
    break;

  case 73: /* type_qualifier: VOLATILE  */
#line 435 "parser.y"
        {
	    debug("Qualifier: volatile\n");
	    (yyval.str) = strdup("volatile");
	}
#line 1692 "parser.tab.c"
    break;

  case 74: /* type_qualifier: RESTRICT  */
#line 440 "parser.y"
        {
	    debug("Qualifier: restrict\n");
	    (yyval.str) = strdup("restrict");
	}
#line 1701 "parser.tab.c"
    break;

  case 75: /* base_type: STRING  */
#line 448 "parser.y"
        {
	    debug("Base type: %s\n", (yyvsp[0].str));
	    (yyval.obj) = obj_basetype_new((yyvsp[0].str));
	}
#line 1710 "parser.tab.c"
    break;

  case 76: /* reference_file: '@' STRING  */
#line 456 "parser.y"
        {
	    (yyval.obj) = obj_reffile_new();
	    (yyval.obj)->base_type = (yyvsp[0].str);
	    }
#line 1719 "parser.tab.c"
    break;

  case 77: /* asm_symbol: IDENTIFIER IDENTIFIER  */
#line 464 "parser.y"
        {
		check_and_free_keyword((yyvsp[-1].str), "assembly");
		(yyval.obj) = obj_assembly_new((yyvsp[0].str));
	}
#line 1728 "parser.tab.c"
    break;

  case 78: /* weak_symbol: IDENTIFIER IDENTIFIER ARROW IDENTIFIER  */
#line 472 "parser.y"
        {
		check_and_free_keyword((yyvsp[-3].str), "weak");
		(yyval.obj) = obj_weak_new((yyvsp[-2].str));
		(yyval.obj)->link = (yyvsp[0].str);
	}
#line 1738 "parser.tab.c"
    break;


#line 1742 "parser.tab.c"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      yyerror (root, YY_("syntax error"));
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, root);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;
  ++yynerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp, root);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturnlab;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturnlab;


/*-----------------------------------------------------------.
| yyexhaustedlab -- YYNOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
yyexhaustedlab:
  yyerror (root, YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturnlab;


/*----------------------------------------------------------.
| yyreturnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
yyreturnlab:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, root);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp, root);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif

  return yyresult;
}

#line 480 "parser.y"


extern void usage(void);

obj_t *obj_parse(FILE *file, char *fn) {
	obj_t *root = NULL;

#ifdef DEBUG
	yydebug = 1;
#else
	yydebug = 0;
#endif

	yyin = file;
	yyparse(&root);
	if (!root)
		fail("No object build for file %s\n", fn);

	return root;
}

int yyerror(obj_t **root, char *s)
{
	fprintf(stderr, "error: %s\n", s);
	return 0;
}
